function renderPDF417Code(map,widthPixels,heightPixels) {
    
    var cols=map[0].length;
    var rows=map.length;
    var r=0;
    var c=0;
    var s='';
    var height=heightPixels;
    var x=widthPixels;
    
    var tablewidth=0;
    for (c=0;c<cols;c++) 
        tablewidth=tablewidth+(map[0][c]*x);
    
    
    s= s + '<table border="0" cellspacing="0" cellpadding="0" width="'+tablewidth+'px">';
  
    var black=false;
    var sizeStr="";
    var whiteStr="";
    var blackStr="";
    s= s + '<tr>';
    black=true;
    for (c=0;c<(tablewidth/x);c++) {  
            
            whiteStr='<td bgcolor="white" height="2px" width="'+x+'px"></td>';
            blackStr='<td bgcolor="white" height="2px" width="'+x+'px"></td>';    
                    
            if (black)  s= s + blackStr;
            else s= s + whiteStr;
              
            black= !black;
        }
    s= s + '</tr>';

    for (r=0;r<rows;r++) {
        black=true;        
        s= s + '<tr>';
        for (c=0;c<cols;c++) {  
            sizeStr=' height="'+height+'px" colspan='+map[r][c]+' ';

            whiteStr='<td bgcolor="white" '+sizeStr+'></td>';
            blackStr='<td bgcolor="black" '+sizeStr+'></td>';    
            
            if (black)  s= s + blackStr;
            else s= s + whiteStr;
              
            black= !black;
        }
        s= s + '</tr>';
    }
    
    s=s+'</table>';
    
    return s;
}


function renderDatamatrix(map, images, msize) {
    
    var cols=map.length;
    var rows=map[0].length;
    var r=0;
    var c=0;
    var s="";
    
    
    s= s + '<table border="0" cellspacing="0" cellpadding="0">';
    
    var sizeStr=' height="'+msize+'px" width="'+msize+'px" ';
    var whiteStr='<td bgcolor="white" '+sizeStr+'></td>';
    var blackStr='<td bgcolor="black" '+sizeStr+'></td>';
    //if (images) blackStr='<td bgcolor="white" background="images/black'+msize+'.png" '+sizeStr+'></td>';
    if (images) blackStr='<td bgcolor="white" '+sizeStr+'><IMG src="images/black'+msize+'.png" /></td>';
    
       
    
    for (r=0;r<rows;r++) {
        s= s + '<tr>';
        for (c=0;c<cols;c++) {  
            if (map[c][r]!=0)
              s= s + blackStr;
            else
              s= s + whiteStr;  
        }
        s= s + '</tr>';
    }
    
    s= s + '</table>';
    
    return s;
}


function renderQRCode(map, images, msize) {
    
    var cols=map.length;
    var rows=map[0].length;
    var r=0;
    var c=0;
    var s="";
    
    
    s= s + '<table border="0" cellspacing="0" cellpadding="0">';
    
    var sizeStr=' height="'+msize+'px" width="'+msize+'px" ';
    var whiteStr='<td bgcolor="white" '+sizeStr+'></td>';
    var blackStr='<td bgcolor="black" '+sizeStr+'></td>';
    //if (images) blackStr='<td bgcolor="white" background="images/black'+msize+'.png" '+sizeStr+'></td>';
    if (images) blackStr='<td bgcolor="white" '+sizeStr+'><IMG src="images/black'+msize+'.png" /></td>';
    
       
    
    for (r=0;r<rows;r++) {
        s= s + '<tr>';
        for (c=0;c<cols;c++) {  
            if (map[c][r]!=0)
              s= s + blackStr;
            else
              s= s + whiteStr;  
        }
        s= s + '</tr>';
    }
    
    s= s + '</table>';
    
    return s;
}

function renderBarcode1D(map, codeText,renderUsingImages ){
  
var cols=map.length;
var c=0;
var s='';
var X=1;
var barHeightPixels=30;
    
var tablewidth=0;
for (c=0;c<cols;c++) { 
    tablewidth=tablewidth+(map[c][0]*X);
        
}
    
    
s= s + '<table border="0" cellspacing="0" cellpadding="0" width="'+tablewidth+'px">';
  
var black=false;
var sizeStr="";
var whiteStr="";
var blackStr="";
s= s + '<tr>';
black=true;
for (c=0;c<(tablewidth/X);c++) {  
            
    whiteStr='<td bgcolor="white" height="2px" width="'+X+'px"></td>';
    blackStr='<td bgcolor="white" height="2px" width="'+X+'px"></td>';    
                    
    if (black)  s= s + blackStr;
    else s= s + whiteStr;
              
    black= !black;
}
s= s + '</tr>';

black=true;        



black=true;    
s= s + '<tr>';
for (c=0;c<cols;c++) {  
    sizeStr=' height="'+barHeightPixels+'px" colspan='+map[c][0]+' ';

        if (!renderUsingImages) {    
            whiteStr='<td bgcolor="white" '+sizeStr+'></td>';
            blackStr='<td bgcolor="black" '+sizeStr+'></td>';    
        } else {
            whiteStr='<td bgcolor="white" '+sizeStr+'></td>';
            blackStr='<td bgcolor="white" '+sizeStr+'><IMG width='+(map[c][0]*X)+' height='+barHeightPixels+' src="images/black3.png" /></td>';            
        }   
            
    if (black)  s= s + blackStr;
    else s= s + whiteStr;
              
    black= !black;
}             
s= s + '</tr>';    

var textFont="Arial";
var textFontSize="1;"
    
if (textFont != null) {
    s= s + '<tr> <td bgcolor="white"  align="center" colspan='+tablewidth+' >';
    s= s +'<font size="'+textFontSize+'" face="'+textFont+'"  >';
    s=s+codeText;
    s= s +'</font>'; 
    s= s + '</td> </tr>';     
}
    
s=s+'</table>';
    
return s;
      
}
